diff --git a/src/backend/access/common/reloptions.c b/src/backend/access/common/reloptions.c
index aa9c0f1..67a6257 100644
--- a/src/backend/access/common/reloptions.c
+++ b/src/backend/access/common/reloptions.c
@@ -984,550 +67,327 @@ extractRelOptions(HeapTuple tuple, TupleDesc tupdesc,
 	switch (classForm->relkind)
 	{
 		case RELKIND_RELATION:
-		case RELKIND_TOASTVALUE:
 		case RELKIND_MATVIEW:
-		case RELKIND_PARTITIONED_TABLE:
-			options = heap_reloptions(classForm->relkind, datum, false);
+			catalog = get_heap_relopt_catalog();
+			break;
+		case RELKIND_TOASTVALUE:
+			catalog = get_toast_relopt_catalog();
 			break;
 		case RELKIND_VIEW:
-			options = view_reloptions(datum, false);
+			catalog = get_view_relopt_catalog();
 			break;
 		case RELKIND_INDEX:
-			options = index_reloptions(amoptions, datum, false);
+			if (catalog_fun)
+				catalog = catalog_fun();
 			break;
 		case RELKIND_FOREIGN_TABLE:
 			options = NULL;
 			break;
+		case RELKIND_PARTITIONED_TABLE:
+			catalog = NULL; /* No options for parted table for now */
+			break;
 		default:
 			Assert(false);		/* can't get here */
 			options = NULL;		/* keep compiler quiet */
 			break;
 	}
 
+	if (catalog)
+		options = optionsTextArrayToBytea(catalog, datum);
 	return options;
 }
 
-/*
- * Interpret reloptions that are given in text-array format.
- *
- * options is a reloption text array as constructed by transformRelOptions.
- * kind specifies the family of options to be processed.
- *
- * The return value is a relopt_value * array on which the options actually
- * set in the options array are marked with isset=true.  The length of this
- * array is returned in *numrelopts.  Options not set are also present in the
- * array; this is so that the caller can easily locate the default values.
- *
- * If there are no options of the given kind, numrelopts is set to 0 and NULL
- * is returned (unless options are illegally supplied despite none being
- * defined, in which case an error occurs).
- *
- * Note: values of type int, bool and real are allocated as part of the
- * returned array.  Values of type string are allocated separately and must
- * be freed by the caller.
- */
-relopt_value *
-parseRelOptions(Datum options, bool validate, relopt_kind kind,
-				int *numrelopts)
-{
-	relopt_value *reloptions = NULL;
-	int			numoptions = 0;
-	int			i;
-	int			j;
-
-	if (need_initialization)
-		initialize_reloptions();
-
-	/* Build a list of expected options, based on kind */
-
-	for (i = 0; relOpts[i]; i++)
-		if (relOpts[i]->kinds & kind)
-			numoptions++;
-
-	if (numoptions > 0)
-	{
-		reloptions = palloc(numoptions * sizeof(relopt_value));
-
-		for (i = 0, j = 0; relOpts[i]; i++)
-		{
-			if (relOpts[i]->kinds & kind)
-			{
-				reloptions[j].gen = relOpts[i];
-				reloptions[j].isset = false;
-				j++;
-			}
-		}
-	}
-
-	/* Done if no options */
-	if (PointerIsValid(DatumGetPointer(options)))
-	{
-		ArrayType  *array = DatumGetArrayTypeP(options);
-		Datum	   *optiondatums;
-		int			noptions;
-
-		deconstruct_array(array, TEXTOID, -1, false, 'i',
-						  &optiondatums, NULL, &noptions);
-
-		for (i = 0; i < noptions; i++)
-		{
-			char	   *text_str = VARDATA(optiondatums[i]);
-			int			text_len = VARSIZE(optiondatums[i]) - VARHDRSZ;
-			int			j;
-
-			/* Search for a match in reloptions */
-			for (j = 0; j < numoptions; j++)
-			{
-				int			kw_len = reloptions[j].gen->namelen;
-
-				if (text_len > kw_len && text_str[kw_len] == '=' &&
-					pg_strncasecmp(text_str, reloptions[j].gen->name,
-								   kw_len) == 0)
-				{
-					parse_one_reloption(&reloptions[j], text_str, text_len,
-										validate);
-					break;
-				}
-			}
-
-			if (j >= numoptions && validate)
-			{
-				char	   *s;
-				char	   *p;
-
-				s = TextDatumGetCString(optiondatums[i]);
-				p = strchr(s, '=');
-				if (p)
-					*p = '\0';
-				ereport(ERROR,
-						(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-						 errmsg("unrecognized parameter \"%s\"", s)));
-			}
-		}
-
-		/* It's worth avoiding memory leaks in this function */
-		pfree(optiondatums);
-		if (((void *) array) != DatumGetPointer(options))
-			pfree(array);
-	}
-
-	*numrelopts = numoptions;
-	return reloptions;
-}
 
 /*
- * Subroutine for parseRelOptions, to parse and validate a single option's
- * value
+ * Here goes functions that build catalogs for non-index relations. Catalogs
+ * for index relations are available from Access Methods, all other
+ * relation catalogs are here
  */
-static void
-parse_one_reloption(relopt_value *option, char *text_str, int text_len,
-					bool validate)
-{
-	char	   *value;
-	int			value_len;
-	bool		parsed;
-	bool		nofree = false;
-
-	if (option->isset && validate)
-		ereport(ERROR,
-				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-				 errmsg("parameter \"%s\" specified more than once",
-						option->gen->name)));
-
-	value_len = text_len - option->gen->namelen - 1;
-	value = (char *) palloc(value_len + 1);
-	memcpy(value, text_str + option->gen->namelen + 1, value_len);
-	value[value_len] = '\0';
-
-	switch (option->gen->type)
-	{
-		case RELOPT_TYPE_BOOL:
-			{
-				parsed = parse_bool(value, &option->values.bool_val);
-				if (validate && !parsed)
-					ereport(ERROR,
-							(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-							 errmsg("invalid value for boolean option \"%s\": %s",
-									option->gen->name, value)));
-			}
-			break;
-		case RELOPT_TYPE_INT:
-			{
-				relopt_int *optint = (relopt_int *) option->gen;
-
-				parsed = parse_int(value, &option->values.int_val, 0, NULL);
-				if (validate && !parsed)
-					ereport(ERROR,
-							(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-							 errmsg("invalid value for integer option \"%s\": %s",
-									option->gen->name, value)));
-				if (validate && (option->values.int_val < optint->min ||
-								 option->values.int_val > optint->max))
-					ereport(ERROR,
-							(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-							 errmsg("value %s out of bounds for option \"%s\"",
-									value, option->gen->name),
-							 errdetail("Valid values are between \"%d\" and \"%d\".",
-									   optint->min, optint->max)));
-			}
-			break;
-		case RELOPT_TYPE_REAL:
-			{
-				relopt_real *optreal = (relopt_real *) option->gen;
-
-				parsed = parse_real(value, &option->values.real_val);
-				if (validate && !parsed)
-					ereport(ERROR,
-							(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-							 errmsg("invalid value for floating point option \"%s\": %s",
-									option->gen->name, value)));
-				if (validate && (option->values.real_val < optreal->min ||
-								 option->values.real_val > optreal->max))
-					ereport(ERROR,
-							(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-							 errmsg("value %s out of bounds for option \"%s\"",
-									value, option->gen->name),
-							 errdetail("Valid values are between \"%f\" and \"%f\".",
-									   optreal->min, optreal->max)));
-			}
-			break;
-		case RELOPT_TYPE_STRING:
-			{
-				relopt_string *optstring = (relopt_string *) option->gen;
-
-				option->values.string_val = value;
-				nofree = true;
-				if (validate && optstring->validate_cb)
-					(optstring->validate_cb) (value);
-				parsed = true;
-			}
-			break;
-		default:
-			elog(ERROR, "unsupported reloption type %d", option->gen->type);
-			parsed = true;		/* quiet compiler */
-			break;
-	}
-
-	if (parsed)
-		option->isset = true;
-	if (!nofree)
-		pfree(value);
-}
 
 /*
- * Given the result from parseRelOptions, allocate a struct that's of the
- * specified base size plus any extra space that's needed for string variables.
+ * Both heap and toast relation have almost the same autovacuum set of options.
+ * These autovacuum options are stored in the same structure (AutoVacOpts)
+ * that is a part of both HeapOptions and ToastOptions.
  *
- * "base" should be sizeof(struct) of the reloptions struct (StdRdOptions or
- * equivalent).
- */
-void *
-allocateReloptStruct(Size base, relopt_value *options, int numoptions)
-{
-	Size		size = base;
-	int			i;
-
-	for (i = 0; i < numoptions; i++)
-		if (options[i].gen->type == RELOPT_TYPE_STRING)
-			size += GET_STRING_RELOPTION_LEN(options[i]) + 1;
-
-	return palloc0(size);
-}
-
-/*
- * Given the result of parseRelOptions and a parsing table, fill in the
- * struct (previously allocated with allocateReloptStruct) with the parsed
- * values.
+ * Function add_autovacuum_options adds to the "catalog" catalog autovacuum
+ * options definition. In binary mode this options are saved into AutoVacOpts
+ * structure, which is located in result bytea chunk with base_offset offset.
  *
- * rdopts is the pointer to the allocated struct to be filled.
- * basesize is the sizeof(struct) that was passed to allocateReloptStruct.
- * options, of length numoptions, is parseRelOptions' output.
- * elems, of length numelems, is the table describing the allowed options.
- * When validate is true, it is expected that all options appear in elems.
+ * Heap has two options (autovacuum_analyze_threshold and
+ * autovacuum_analyze_scale_factor) that is not used for toast. So for toast
+ * case this options are added to catalog with OPTION_DEFINITION_FLAG_REJECT
+ * flag set, so postgres will reject this toast options from the CREATE or
+ * ALTER command, but still will save default value in binary representation
  */
+
 void
-fillRelOptions(void *rdopts, Size basesize,
-			   relopt_value *options, int numoptions,
-			   bool validate,
-			   const relopt_parse_elt *elems, int numelems)
+add_autovacuum_options(options_catalog * catalog, int base_offset,
+					   bool for_toast)
 {
-	int			i;
-	int			offset = basesize;
-
-	for (i = 0; i < numoptions; i++)
-	{
-		int			j;
-		bool		found = false;
-
-		for (j = 0; j < numelems; j++)
-		{
-			if (pg_strcasecmp(options[i].gen->name, elems[j].optname) == 0)
-			{
-				relopt_string *optstring;
-				char	   *itempos = ((char *) rdopts) + elems[j].offset;
-				char	   *string_val;
-
-				switch (options[i].gen->type)
-				{
-					case RELOPT_TYPE_BOOL:
-						*(bool *) itempos = options[i].isset ?
-							options[i].values.bool_val :
-							((relopt_bool *) options[i].gen)->default_val;
-						break;
-					case RELOPT_TYPE_INT:
-						*(int *) itempos = options[i].isset ?
-							options[i].values.int_val :
-							((relopt_int *) options[i].gen)->default_val;
-						break;
-					case RELOPT_TYPE_REAL:
-						*(double *) itempos = options[i].isset ?
-							options[i].values.real_val :
-							((relopt_real *) options[i].gen)->default_val;
-						break;
-					case RELOPT_TYPE_STRING:
-						optstring = (relopt_string *) options[i].gen;
-						if (options[i].isset)
-							string_val = options[i].values.string_val;
-						else if (!optstring->default_isnull)
-							string_val = optstring->default_val;
-						else
-							string_val = NULL;
-
-						if (string_val == NULL)
-							*(int *) itempos = 0;
-						else
-						{
-							strcpy((char *) rdopts + offset, string_val);
-							*(int *) itempos = offset;
-							offset += strlen(string_val) + 1;
-						}
-						break;
-					default:
-						elog(ERROR, "unsupported reloption type %d",
-							 options[i].gen->type);
-						break;
-				}
-				found = true;
-				break;
-			}
-		}
-		if (validate && !found)
-			elog(ERROR, "reloption \"%s\" not found in parse table",
-				 options[i].gen->name);
-	}
-	SET_VARSIZE(rdopts, offset);
+	optionsCatalogAddItemBool(catalog, "autovacuum_enabled",
+							  "Enables autovacuum in this relation",
+							  ShareUpdateExclusiveLock,
+					  0, base_offset + offsetof(AutoVacOpts, enabled), true);
+
+	optionsCatalogAddItemInt(catalog, "autovacuum_vacuum_threshold",
+				"Minimum number of tuple updates or deletes prior to vacuum",
+							 ShareUpdateExclusiveLock,
+					0, base_offset + offsetof(AutoVacOpts, vacuum_threshold),
+							 -1, 0, INT_MAX);
+
+	optionsCatalogAddItemInt(catalog, "autovacuum_analyze_threshold",
+				"Minimum number of tuple updates or deletes prior to vacuum",
+							 ShareUpdateExclusiveLock,
+							 for_toast ? OPTION_DEFINITION_FLAG_REJECT : 0,
+					  base_offset + offsetof(AutoVacOpts, analyze_threshold),
+							 -1, 0, INT_MAX);
+
+	optionsCatalogAddItemInt(catalog, "autovacuum_vacuum_cost_delay",
+						 "Vacuum cost delay in milliseconds, for autovacuum",
+							 ShareUpdateExclusiveLock,
+				   0, base_offset + offsetof(AutoVacOpts, vacuum_cost_delay),
+							 -1, 0, 100);
+
+	optionsCatalogAddItemInt(catalog, "autovacuum_vacuum_cost_limit",
+			   "Vacuum cost amount available before napping, for autovacuum",
+							 ShareUpdateExclusiveLock,
+				   0, base_offset + offsetof(AutoVacOpts, vacuum_cost_limit),
+							 -1, 0, 10000);
+
+	optionsCatalogAddItemInt(catalog, "autovacuum_freeze_min_age",
+	 "Minimum age at which VACUUM should freeze a table row, for autovacuum",
+							 ShareUpdateExclusiveLock,
+					  0, base_offset + offsetof(AutoVacOpts, freeze_min_age),
+							 -1, 0, 1000000000);
+
+	optionsCatalogAddItemInt(catalog, "autovacuum_freeze_max_age",
+	"Age at which to autovacuum a table to prevent transaction ID wraparound",
+							 ShareUpdateExclusiveLock,
+					  0, base_offset + offsetof(AutoVacOpts, freeze_max_age),
+							 -1, 100000, 2000000000);
+
+	optionsCatalogAddItemInt(catalog, "autovacuum_freeze_table_age",
+							 "Age at which VACUUM should perform a full table sweep to freeze row versions",
+							 ShareUpdateExclusiveLock,
+					0, base_offset + offsetof(AutoVacOpts, freeze_table_age),
+							 -1, 0, 2000000000);
+
+	optionsCatalogAddItemInt(catalog, "autovacuum_multixact_freeze_min_age",
+							 "Minimum multixact age at which VACUUM should freeze a row multixact's, for autovacuum",
+							 ShareUpdateExclusiveLock,
+			0, base_offset + offsetof(AutoVacOpts, multixact_freeze_min_age),
+							 -1, 0, 1000000000);
+
+	optionsCatalogAddItemInt(catalog, "autovacuum_multixact_freeze_max_age",
+							 "Multixact age at which to autovacuum a table to prevent multixact wraparound",
+							 ShareUpdateExclusiveLock,
+			0, base_offset + offsetof(AutoVacOpts, multixact_freeze_max_age),
+							 -1, 10000, 2000000000);
+
+	optionsCatalogAddItemInt(catalog, "autovacuum_multixact_freeze_table_age",
+							 "Age of multixact at which VACUUM should perform a full table sweep to freeze row versions",
+							 ShareUpdateExclusiveLock,
+		  0, base_offset + offsetof(AutoVacOpts, multixact_freeze_table_age),
+							 -1, 0, 2000000000);
+
+	optionsCatalogAddItemInt(catalog, "log_autovacuum_min_duration",
+							 "Sets the minimum execution time above which autovacuum actions will be logged",
+							 ShareUpdateExclusiveLock,
+					0, base_offset + offsetof(AutoVacOpts, log_min_duration),
+							 -1, -1, INT_MAX);
+
+	optionsCatalogAddItemReal(catalog, "autovacuum_vacuum_scale_factor",
+							  "Number of tuple updates or deletes prior to vacuum as a fraction of reltuples",
+							  ShareUpdateExclusiveLock,
+				 0, base_offset + offsetof(AutoVacOpts, vacuum_scale_factor),
+							  -1, 0.0, 100.0);
+
+	optionsCatalogAddItemReal(catalog, "autovacuum_analyze_scale_factor",
+							  "Number of tuple inserts, updates or deletes prior to analyze as a fraction of reltuples",
+							  ShareUpdateExclusiveLock,
+							  for_toast ? OPTION_DEFINITION_FLAG_REJECT : 0,
+				   base_offset + offsetof(AutoVacOpts, analyze_scale_factor),
+							  -1, 0.0, 100.0);
 }
 
-
 /*
- * Option parser for anything that uses StdRdOptions.
+ * get_heap_relopt_catalog
+ *		Returns an options catalog for heap relation.
  */
-bytea *
-default_reloptions(Datum reloptions, bool validate, relopt_kind kind)
-{
-	relopt_value *options;
-	StdRdOptions *rdopts;
-	int			numoptions;
-	static const relopt_parse_elt tab[] = {
-		{"fillfactor", RELOPT_TYPE_INT, offsetof(StdRdOptions, fillfactor)},
-		{"autovacuum_enabled", RELOPT_TYPE_BOOL,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, enabled)},
-		{"autovacuum_vacuum_threshold", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, vacuum_threshold)},
-		{"autovacuum_analyze_threshold", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, analyze_threshold)},
-		{"autovacuum_vacuum_cost_delay", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, vacuum_cost_delay)},
-		{"autovacuum_vacuum_cost_limit", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, vacuum_cost_limit)},
-		{"autovacuum_freeze_min_age", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, freeze_min_age)},
-		{"autovacuum_freeze_max_age", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, freeze_max_age)},
-		{"autovacuum_freeze_table_age", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, freeze_table_age)},
-		{"autovacuum_multixact_freeze_min_age", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, multixact_freeze_min_age)},
-		{"autovacuum_multixact_freeze_max_age", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, multixact_freeze_max_age)},
-		{"autovacuum_multixact_freeze_table_age", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, multixact_freeze_table_age)},
-		{"log_autovacuum_min_duration", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, log_min_duration)},
-		{"toast_tuple_target", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, toast_tuple_target)},
-		{"autovacuum_vacuum_scale_factor", RELOPT_TYPE_REAL,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, vacuum_scale_factor)},
-		{"autovacuum_analyze_scale_factor", RELOPT_TYPE_REAL,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, analyze_scale_factor)},
-		{"user_catalog_table", RELOPT_TYPE_BOOL,
-		offsetof(StdRdOptions, user_catalog_table)},
-		{"parallel_workers", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, parallel_workers)}
-	};
+static options_catalog *heap_relopt_catalog = NULL;
 
-	options = parseRelOptions(reloptions, validate, kind, &numoptions);
-
-	/* if none set, we're done */
-	if (numoptions == 0)
-		return NULL;
-
-	rdopts = allocateReloptStruct(sizeof(StdRdOptions), options, numoptions);
-
-	fillRelOptions((void *) rdopts, sizeof(StdRdOptions), options, numoptions,
-				   validate, tab, lengthof(tab));
-
-	pfree(options);
-
-	return (bytea *) rdopts;
+options_catalog *
+get_heap_relopt_catalog(void)
+{
+	if (!heap_relopt_catalog)
+	{
+		heap_relopt_catalog = allocateOptionsCatalog(NULL, sizeof(HeapOptions),
+													 14 + 5);	/* 14 - for autovacuum
+																 * options, 4 - core
+																 * heap options */
+
+		optionsCatalogAddItemInt(heap_relopt_catalog, "fillfactor",
+								 "Packs table pages only to this percentag",
+								 ShareUpdateExclusiveLock,		/* since it applies only
+																 * to later inserts */
+								 0, offsetof(HeapOptions, fillfactor),
+						  HEAP_DEFAULT_FILLFACTOR, HEAP_MIN_FILLFACTOR, 100);
+
+		optionsCatalogAddItemInt(heap_relopt_catalog, "toast_tuple_target",
+								 "Sets the target tuple length at which external columns will be toasted",
+								 ShareUpdateExclusiveLock,
+								 0, offsetof(HeapOptions, toast_tuple_target),
+						  TOAST_TUPLE_TARGET, 128, TOAST_TUPLE_TARGET_MAIN);
+
+		add_autovacuum_options(heap_relopt_catalog,
+							   offsetof(HeapOptions, autovacuum), false);
+
+		optionsCatalogAddItemBool(heap_relopt_catalog, "user_catalog_table",
+								  "Declare a table as an additional catalog table, e.g. for the purpose of logical replication",
+								  AccessExclusiveLock,
+								0, offsetof(HeapOptions, user_catalog_table),
+								  false);
+
+		optionsCatalogAddItemInt(heap_relopt_catalog, "parallel_workers",
+								 "Number of parallel processes that can be used per executor node for this relation",
+								 ShareUpdateExclusiveLock,
+								 0, offsetof(HeapOptions, parallel_workers),
+								 -1, 0, 1024);
+
+		/*
+		 * A WITH OID / WITHOUT OIDS expressions are converted by syntax
+		 * parser into "oids" relation option, but this option is processed by
+		 * interpretOidsOption(), that does not use core options code. That is
+		 * why here we should just ignore this option as if it does not exist.
+		 * Do it with OPTION_DEFINITION_FLAG_IGNORE flag
+		 */
+		optionsCatalogAddItemBool(heap_relopt_catalog, "oids",
+				 "Option used for WITH OIDS expression. Processed elsewhere",
+								  NoLock,
+								  OPTION_DEFINITION_FLAG_IGNORE, -1,
+								  false);
+	}
+	return heap_relopt_catalog;
 }
 
 /*
- * Option parser for views
+ * get_toast_relopt_catalog
+ *		Returns an options catalog for toast relation.
  */
-bytea *
-view_reloptions(Datum reloptions, bool validate)
-{
-	relopt_value *options;
-	ViewOptions *vopts;
-	int			numoptions;
-	static const relopt_parse_elt tab[] = {
-		{"security_barrier", RELOPT_TYPE_BOOL,
-		offsetof(ViewOptions, security_barrier)},
-		{"check_option", RELOPT_TYPE_STRING,
-		offsetof(ViewOptions, check_option_offset)}
-	};
-
-	options = parseRelOptions(reloptions, validate, RELOPT_KIND_VIEW, &numoptions);
-
-	/* if none set, we're done */
-	if (numoptions == 0)
-		return NULL;
 
-	vopts = allocateReloptStruct(sizeof(ViewOptions), options, numoptions);
+static options_catalog *toast_relopt_catalog = NULL;
 
-	fillRelOptions((void *) vopts, sizeof(ViewOptions), options, numoptions,
-				   validate, tab, lengthof(tab));
-
-	pfree(options);
-
-	return (bytea *) vopts;
-}
-
-/*
- * Parse options for heaps, views and toast tables.
- */
-bytea *
-heap_reloptions(char relkind, Datum reloptions, bool validate)
+options_catalog *
+get_toast_relopt_catalog(void)
 {
-	StdRdOptions *rdopts;
-
-	switch (relkind)
+	if (!toast_relopt_catalog)
 	{
-		case RELKIND_TOASTVALUE:
-			rdopts = (StdRdOptions *)
-				default_reloptions(reloptions, validate, RELOPT_KIND_TOAST);
-			if (rdopts != NULL)
-			{
-				/* adjust default-only parameters for TOAST relations */
-				rdopts->fillfactor = 100;
-				rdopts->autovacuum.analyze_threshold = -1;
-				rdopts->autovacuum.analyze_scale_factor = -1;
-			}
-			return (bytea *) rdopts;
-		case RELKIND_RELATION:
-		case RELKIND_MATVIEW:
-			return default_reloptions(reloptions, validate, RELOPT_KIND_HEAP);
-		case RELKIND_PARTITIONED_TABLE:
-			return default_reloptions(reloptions, validate,
-									  RELOPT_KIND_PARTITIONED);
-		default:
-			/* other relkinds are not supported */
-			return NULL;
+		toast_relopt_catalog = allocateOptionsCatalog("toast", sizeof(ToastOptions),
+													  14);		/* 14 - for autovacuum
+																 * options */
+		add_autovacuum_options(toast_relopt_catalog,
+							   offsetof(ToastOptions, autovacuum), true);
 	}
+	return toast_relopt_catalog;
 }
 
-
 /*
- * Parse options for indexes.
- *
- *	amoptions	index AM's option parser function
- *	reloptions	options as text[] datum
- *	validate	error flag
+ * get_view_relopt_catalog
+ *		Returns an options catalog for view relation.
  */
-bytea *
-index_reloptions(amoptions_function amoptions, Datum reloptions, bool validate)
+static options_catalog *view_relopt_catalog = NULL;
+
+options_catalog *
+get_view_relopt_catalog(void)
 {
-	Assert(amoptions != NULL);
+	static const char *enum_names[] = VIEW_OPTION_CHECK_OPTION_VALUE_NAMES;
 
-	/* Assume function is strict */
-	if (!PointerIsValid(DatumGetPointer(reloptions)))
-		return NULL;
+	if (!view_relopt_catalog)
+	{
+		view_relopt_catalog = allocateOptionsCatalog(NULL,
+													 sizeof(ViewOptions), 2);
 
-	return amoptions(reloptions, validate);
+		optionsCatalogAddItemBool(view_relopt_catalog, "security_barrier",
+								  "View acts as a row security barrier",
+								  AccessExclusiveLock,
+						  0, offsetof(ViewOptions, security_barrier), false);
+
+		optionsCatalogAddItemEnum(view_relopt_catalog, "check_option",
+					"View has WITH CHECK OPTION defined (local or cascaded)",
+								  AccessExclusiveLock, 0,
+								  offsetof(ViewOptions, check_option),
+								  enum_names,
+								  VIEW_OPTION_CHECK_OPTION_NOT_SET);
+	}
+	return view_relopt_catalog;
 }
 
 /*
- * Option parser for attribute reloptions
+ * get_attribute_options_catalog
+ *		Returns an options catalog for heap attributes
  */
-bytea *
-attribute_reloptions(Datum reloptions, bool validate)
-{
-	relopt_value *options;
-	AttributeOpts *aopts;
-	int			numoptions;
-	static const relopt_parse_elt tab[] = {
-		{"n_distinct", RELOPT_TYPE_REAL, offsetof(AttributeOpts, n_distinct)},
-		{"n_distinct_inherited", RELOPT_TYPE_REAL, offsetof(AttributeOpts, n_distinct_inherited)}
-	};
-
-	options = parseRelOptions(reloptions, validate, RELOPT_KIND_ATTRIBUTE,
-							  &numoptions);
-
-	/* if none set, we're done */
-	if (numoptions == 0)
-		return NULL;
-
-	aopts = allocateReloptStruct(sizeof(AttributeOpts), options, numoptions);
+static options_catalog *attribute_options_catalog = NULL;
 
-	fillRelOptions((void *) aopts, sizeof(AttributeOpts), options, numoptions,
-				   validate, tab, lengthof(tab));
+options_catalog *
+get_attribute_options_catalog(void)
+{
+	if (!attribute_options_catalog)
+	{
+		attribute_options_catalog = allocateOptionsCatalog(NULL,
+												   sizeof(AttributeOpts), 2);
 
-	pfree(options);
+		optionsCatalogAddItemReal(attribute_options_catalog, "n_distinct",
+								  "Sets the planner's estimate of the number of distinct values appearing in a column (excluding child relations)",
+								  ShareUpdateExclusiveLock,
+				   0, offsetof(AttributeOpts, n_distinct), 0, -1.0, DBL_MAX);
 
-	return (bytea *) aopts;
+		optionsCatalogAddItemReal(attribute_options_catalog,
+								  "n_distinct_inherited",
+								  "Sets the planner's estimate of the number of distinct values appearing in a column (including child relations",
+								  ShareUpdateExclusiveLock,
+		 0, offsetof(AttributeOpts, n_distinct_inherited), 0, -1.0, DBL_MAX);
+	}
+	return attribute_options_catalog;
 }
 
 /*
- * Option parser for tablespace reloptions
+ * get_tablespace_options_catalog
+ *		Returns an options catalog for tablespaces
  */
-bytea *
-tablespace_reloptions(Datum reloptions, bool validate)
-{
-	relopt_value *options;
-	TableSpaceOpts *tsopts;
-	int			numoptions;
-	static const relopt_parse_elt tab[] = {
-		{"random_page_cost", RELOPT_TYPE_REAL, offsetof(TableSpaceOpts, random_page_cost)},
-		{"seq_page_cost", RELOPT_TYPE_REAL, offsetof(TableSpaceOpts, seq_page_cost)},
-		{"effective_io_concurrency", RELOPT_TYPE_INT, offsetof(TableSpaceOpts, effective_io_concurrency)}
-	};
-
-	options = parseRelOptions(reloptions, validate, RELOPT_KIND_TABLESPACE,
-							  &numoptions);
-
-	/* if none set, we're done */
-	if (numoptions == 0)
-		return NULL;
-
-	tsopts = allocateReloptStruct(sizeof(TableSpaceOpts), options, numoptions);
-
-	fillRelOptions((void *) tsopts, sizeof(TableSpaceOpts), options, numoptions,
-				   validate, tab, lengthof(tab));
-
-	pfree(options);
+static options_catalog *tablespace_options_catalog = NULL;
 
-	return (bytea *) tsopts;
+options_catalog *
+get_tablespace_options_catalog(void)
+{
+	if (!tablespace_options_catalog)
+	{
+		tablespace_options_catalog = allocateOptionsCatalog(NULL,
+												  sizeof(TableSpaceOpts), 3);
+
+		optionsCatalogAddItemReal(tablespace_options_catalog,
+								  "random_page_cost",
+								  "Sets the planner's estimate of the cost of a nonsequentially fetched disk page",
+								  ShareUpdateExclusiveLock,
+			0, offsetof(TableSpaceOpts, random_page_cost), -1, 0.0, DBL_MAX);
+
+		optionsCatalogAddItemReal(tablespace_options_catalog, "seq_page_cost",
+								  "Sets the planner's estimate of the cost of a sequentially fetched disk page",
+								  ShareUpdateExclusiveLock,
+			   0, offsetof(TableSpaceOpts, seq_page_cost), -1, 0.0, DBL_MAX);
+
+		optionsCatalogAddItemInt(tablespace_options_catalog,
+								 "effective_io_concurrency",
+								 "Number of simultaneous requests that can be handled efficiently by the disk subsystem",
+								 ShareUpdateExclusiveLock,
+					   0, offsetof(TableSpaceOpts, effective_io_concurrency),
+#ifdef USE_PREFETCH
+								 -1, 0, MAX_IO_CONCURRENCY
+#else
+								 0, 0, 0
+#endif
+			);
+	}
+	return tablespace_options_catalog;
 }
 
 /*
@@ -1537,33 +397,56 @@ tablespace_reloptions(Datum reloptions, bool validate)
  * for a longer explanation of how this works.
  */
 LOCKMODE
-AlterTableGetRelOptionsLockLevel(List *defList)
+AlterTableGetRelOptionsLockLevel(Relation rel, List *defList)
 {
 	LOCKMODE	lockmode = NoLock;
 	ListCell   *cell;
+	options_catalog *catalog = NULL;
 
 	if (defList == NIL)
 		return AccessExclusiveLock;
 
-	if (need_initialization)
-		initialize_reloptions();
+	switch (rel->rd_rel->relkind)
+	{
+		case RELKIND_TOASTVALUE:
+			catalog = get_toast_relopt_catalog();
+			break;
+		case RELKIND_RELATION:
+		case RELKIND_MATVIEW:
+			catalog = get_heap_relopt_catalog();
+			break;
+		case RELKIND_INDEX:
+			catalog = rel->rd_amroutine->amrelopt_catalog();
+			break;
+		case RELKIND_VIEW:
+			catalog = get_view_relopt_catalog();
+			break;
+		case RELKIND_PARTITIONED_TABLE:
+			catalog = NULL; /* No options for parted table for now */
+			break;
+		default:
+			Assert(false);		/* can't get here */
+			break;
+	}
+
+	Assert(catalog);			/* No catalog - no reloption change. Should
+								 * not get here */
 
 	foreach(cell, defList)
 	{
 		DefElem    *def = (DefElem *) lfirst(cell);
+
 		int			i;
 
-		for (i = 0; relOpts[i]; i++)
+		for (i = 0; i < catalog->num; i++)
 		{
-			if (pg_strncasecmp(relOpts[i]->name,
-							   def->defname,
-							   relOpts[i]->namelen + 1) == 0)
-			{
-				if (lockmode < relOpts[i]->lockmode)
-					lockmode = relOpts[i]->lockmode;
-			}
+			option_definition_basic *gen = catalog->definitions[i];
+
+			if (pg_strcasecmp(gen->name,
+							  def->defname) == 0)
+				if (lockmode < gen->lockmode)
+					lockmode = gen->lockmode;
 		}
 	}
-
 	return lockmode;
 }
